<%-- $Id: reset_filters.jsp 6607 2014-11-19 14:52:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ToStringComparator"
	import="net.sf.basedb.util.NestedIterator"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.TreeSet"
	import="java.util.HashSet"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String activePage = request.getParameter("page");
final DbControl dc = sc.newDbControl();
try
{
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String title = "Reset list settings for "+HTML.encodeTags(user.getName());
	final List<ItemContext> inMemory = sc.getAllCurrentContexts(true, false);
	final List<ItemContext> inDatabase = sc.getAllCurrentContexts(false, true);
	final Set<Item> items = new TreeSet<Item>(new ToStringComparator<Item>(false));
	final Set<Item> dbOnly = new HashSet<Item>();
	Iterator<ItemContext> it = new NestedIterator(inMemory, inDatabase);
	for (ItemContext ctx : inMemory)
	{
		if (ctx.getNumPropertyFilters() > 0 || ctx.getSortProperty() != null)
		{
			items.add(ctx.getItemType());
		}
	}
	for (ItemContext ctx : inDatabase)
	{
		if (ctx.getNumPropertyFilters() > 0 || ctx.getSortProperty() != null)
		{
			if (items.add(ctx.getItemType())) dbOnly.add(ctx.getItemType());
		}
	}
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="~reset_filters.js" />
	<base:body>
		<h1><%=title%><base:help helpid="userpreferences.resetfilters" /></h1>
		<form action="submit_user.jsp?ID=<%=ID%>" method="post" name="filters">
		<input type=hidden name="cmd" value="ResetFilters">

		<div class="content">
			<table class="fullform smaller bottomborder">
			<tr>
				<th>Which list?</th>
				<td>
					<select name="item_type" id="itemType" class="selectionlist">
						<option value="">- all -
						<%
						for (Item item : items)
						{
							%>
							<option value="<%=item.name()%>"><%=dbOnly.contains(item) ? "* " : "" %><%=item%>
							<%
						}
						%>
					</select><br>
					* = This setting is only in the database
				</td>
			</tr>
			<tr class="double">
				<th>Location</th>
				<td>
				<input type="checkbox" name="memory" id="memory" value="1" checked disabled>In-memory<br>
				<input type="checkbox" name="database" id="database" value="1"><label for="database">In-database</label>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td>
					<div class="padded">
					Use this functionality if you are experiencing problems when listing
					items on a list page. Try first with only the 'In-memory' option selected.
					If that doesn't help, try the 'In-database' option.
					</div>
				</td>
			</tr>
			</table>

		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
