/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var SaveAs = function()
{
	var saveas = {};
	
	/**
		Initialize the page.
	*/
	saveas.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
		
		var frm = document.forms['saveas'];
		var lastPath = Data.getPageValue('last-path');
		if (lastPath) 
		{
			frm.path.value = lastPath;
		}
		frm.path.focus();
		
		Buttons.addClickHandler('btnSave', saveas.saveAs);
		Buttons.addClickHandler('btnBrowse', saveas.browseOnClick);
		Events.addEventHandler('path', 'base-selected', saveas.setSaveAsCallback);

	}
	
	saveas.validateForm = function()
	{
		var frm = document.forms['saveas'];
		if (Strings.trim(frm.path.value) == '')
		{
			Forms.showNotification(frm.path, 'Please enter a filename');
			return false;
		}
		return true;
	}
	
	saveas.saveAs = function()
	{
		var frm = document.forms['saveas'];
		if (saveas.validateForm())
		{
			var plotUrl = Data.get('page-data', 'plot-url');
			if (plotUrl)
			{
				Data.setPageValue('last-path', frm.path.value);
				plotUrl += '&saveAs=' + encodeURIComponent(frm.path.value);
				plotUrl += '&overwrite=' + (frm.overwrite.checked ? 1 : 0);
				Doc.hide('save');
				Doc.hide('buttons');
				Doc.show('generating');
				location.href = plotUrl;
			}
		}
	}


	saveas.browseOnClick = function()
	{
		var url = App.getRoot() +'filemanager/index.jsp?ID='+App.getSessionId();
		url += '&cmd=SaveAs&callback=path';
		Dialogs.openPopup(url, 'SaveAs', 1050, 700);
	}
	
	saveas.setSaveAsCallback = function(event)
	{
		var frm = document.forms['saveas'];
		frm.path.value = event.detail.path;
	}

	return saveas;
}();

Doc.onLoad(SaveAs.initPage);
